#include <cstdio>
#include <cstdlib>
#include <vector>
using namespace std;

void bad(const char *err)
{
  printf("0\n");
  fprintf(stderr, "translate:wrong\n");
  exit(1);
}

struct edge
{
  int f, t, delta;

  edge(int _f, int _t, int _d):f(_f), t(_t), delta(_d)
    {
    }
};

int main (int argc, char *argv[])
{
  if (argc != 4)
    return 2;
  char *arg_in = argv[1];
  char *arg_correct = argv[2];
  char *arg_tested = argv[3];

  int n, m;

  FILE *zad = fopen (arg_in, "r");
  if (fscanf (zad, "%d%d", &n, &m) != 2)
    abort ();

  vector<edge> gph;
  for (int i = 0; i < m; ++i)
    {
      int f, t, a, b;

      if (fscanf (zad, "%d%d%d%d", &f, &t, &a, &b) != 4)
	abort ();

      gph.push_back (edge (f, t, a-b));
    }
  fclose (zad);

  FILE *cor = fopen (arg_correct, "r");
  int cr;
  if (fscanf (cor, "%d", &cr) != 1)
    abort ();
  fclose (cor);

  freopen(arg_tested, "r", stdin);
  int ae;
  if (scanf ("%d", &ae) != 1)
    {
      bad ("Vystup nezacina cislem.\n");
    }
  if (ae == 0)
    {
      if (cr == 0)
        {
	  fprintf(stderr, "translate:success\n");
	  printf("1\n");
	  return 0;
	}

      bad ("Vylet existuje, ale reseni tvrdi ze ne.\n");
    }

  if (ae <= 0 || ae > m)
    {
      bad ("Chybne cislo hrany\n");
    }
  ae--;
  int sv = gph[ae].f;
  int del = gph[ae].delta;
  int av = gph[ae].t;

  int last = ae;
  while (scanf ("%d", &ae) == 1)
    {
      if (ae <= 0 || ae > m)
	{
	  bad ("Chybne cislo hrany\n");
	  return 1;
	}
      ae--;
      if (gph[ae].f != av)
	{
	  bad ("Hrana nenavazuje na predchozi.\n");
	  return 1;
	}
      del += gph[ae].delta;
      av = gph[ae].t;

      last = ae;
    }

  if (!feof (stdin))
    {
      bad ("Vystup nekonci poslednim cislem.\n");
    }

  if (av != sv)
    {
      bad ("Vylet nekonci tam, kde zacal.\n");
    }

  if (del == 0)
    {
      bad ("Za vylet ziskaji oba stejne bonbonu.\n");
    }

  if (cr == 0)
    {
      fprintf (stderr, "Chyba v nasich resenich, tvrdi, ze vylet neexistuje, ale neni tomu tak.\n");
      abort ();
    }


  fprintf(stderr, "translate:success\n");
  printf("1\n");
  return 0;
}
